import pygame
from .pacman import *
from .fantasma import *
from .elementojogo import *
from .variaveis import *

#inicializando variáveis 
pygame.font.init()
variaveis = VariaveisGlobais()

tela = pygame.display.set_mode((800, 600), 0)
fonte = pygame.font.SysFont("GOUDY STOUT", 18, True, False) 
fonte_estados = pygame.font.SysFont("GOUDY STOUT", 32, True, False) 

class Board(ElementoJogo):
    def __init__(self, tamanho, pacman):
        self.pacman = pacman
        self.moviveis = []
        self.tamanho = tamanho
        self.pontos = 0
        self.vidas = 5
        self.estado = "Jogando" #Estados possíveis *Jogando *Pausado *GameOver *Vitória
        self.matriz = [
            [2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2],
            [2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 2],
            [2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2],
            [2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2],
            [2, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 0, 0, 0, 0, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 0, 0, 0, 0, 0, 0, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 1, 1, 1, 1, 1, 2, 2, 1, 2, 0, 0, 0, 0, 0, 0, 2, 1, 2, 2, 1, 1, 1, 1, 1, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 0, 0, 0, 0, 0, 0, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 2],
            [2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2],
            [2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2],
            [2, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 1, 1, 1, 1, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 1, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 1, 2],
            [2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2],
            [2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2]
        ]

    def adicionar_movivel(self, obj):
        self.moviveis.append(obj)

    #Pintando score contendo vidas e pontos do jogo
    def pintar_score(self, tela):
        pontos_x = 30 * self.tamanho
        img_pontos = fonte.render(f"Score: {self.pontos} ", True, variaveis.amarelo)
        img_vidas = fonte.render(f"Vidas: {self.vidas} ", True, variaveis.amarelo)

        tela.blit(img_pontos,(pontos_x, 50))
        tela.blit(img_vidas,(pontos_x, 100))

    #Pintando o cenário e as pilulas do pacman na tela
    def pintar_linha(self, numero_linha, linha):
        for numero_coluna, coluna in enumerate(linha):
            x = numero_coluna * self.tamanho
            y = numero_linha * self.tamanho
            half = self.tamanho // 2
            cor = variaveis.preto

            if coluna == 2:
                cor = variaveis.azul
            pygame.draw.rect(tela, cor, (x, y, self.tamanho, self.tamanho), 0)

            if coluna == 1:
                pygame.draw.circle(tela, variaveis.branco, (x + half, y + half), self.tamanho // 10, 0)

    def pintar(self, tela):
        if self.estado == "Jogando":
            self.pintar_jogando(tela)
        elif self.estado == "Pausado":
            self.pintar_jogando(tela)
            self.pintar_pausado(tela)
        elif self.estado == "GameOver":
            self.pintar_jogando(tela)
            self.pintar_gameover(tela)
        elif self.estado == "Vitoria":
            self.pintar_jogando(tela)
            self.pintar_vitoria(tela)
    

    def pintar_texto_centro(self, tela, texto):
        texto_img = fonte_estados.render(texto, True, variaveis.amarelo)
        texto_x = (tela.get_width() - texto_img.get_width()) // 2
        texto_y = (tela.get_height() - texto_img.get_height()) // 2
        tela.blit (texto_img, (texto_x, texto_y))

    def pintar_vitoria(self, tela):
        self.pintar_texto_centro(tela, "V O C E  V E N C E U  !!")

    def pintar_gameover(self, tela):
        self.pintar_texto_centro(tela, "G A M E   O V E R !")

    def pintar_pausado(self, tela):
        self.pintar_texto_centro(tela, "P A U S A D O")

    def pintar_jogando(self, tela):
        for numero_linha, linha in enumerate(self.matriz):
            self.pintar_linha(numero_linha, linha)
        self.pintar_score(tela)

    def get_direcoes(self, linha, coluna):
        direcoes = []

        if self.matriz[int(linha - 1)][int(coluna)] != 2:
            direcoes.append(variaveis.a_cima)
        if self.matriz[int(linha + 1)][int(coluna)] != 2:
            direcoes.append(variaveis.a_baixo)
        if self.matriz[int(linha)][int(coluna - 1)] != 2:
            direcoes.append(variaveis.a_esquerda)
        if self.matriz[int(linha)][int(coluna + 1)] != 2:
            direcoes.append(variaveis.a_direita)

        return direcoes
    
    def calcular_regras(self):
        if self.estado == "Jogando":
            self.calcular_regras_jogando()
        elif self.estado == "Pausado":
            self.calcular_regras_pausado()
        elif self.estado == "GameOver":
            self.calcular_regras_gameover()

    def calcular_regras_gameover(self):
        pass

    def calcular_regras_pausado(self):
        pass
    
    def calcular_regras_jogando(self):
        for movivel in self.moviveis:
            lin = int(movivel.linha)
            col = int(movivel.coluna)

            lin_intencao = int(movivel.linha_intencao)
            col_intencao = int(movivel.coluna_intencao)

            direcoes = self.get_direcoes(lin, col)

            if len(direcoes) >= 3:
                movivel.esquina(direcoes)
            
            pacman_mesma_linha_fantasma = (movivel.linha == self.pacman.linha)
            pacman_mesma_coluna_fantasma = (movivel.coluna == self.pacman.coluna)
            condicao_gameover = (isinstance(movivel, Fantasma) and \
                                  pacman_mesma_linha_fantasma  and \
                                  pacman_mesma_coluna_fantasma)

            if condicao_gameover:
                self.vidas -= 1
                if self.vidas <= 0:
                    self.estado = "GameOver"
                else:
                    self.pacman.linha = 1
                    self.pacman.coluna = 1

            else:

                if 0 <= col_intencao < 28  and 0 <= lin_intencao < 29 and\
                            self.matriz[lin_intencao][col_intencao] != 2:
                    movivel.aceitar_movimento()
                    if isinstance(movivel, Pacman) and self.matriz[lin][col] == 1:
                        self.pontos += 1
                        self.matriz[lin][col] = 0

                        if self.pontos >= 306:
                            self.estado = "Vitoria"

                else:
                    movivel.recusar_movimento(direcoes)
    
    def processar_eventos(self, eventos):
        for e in eventos:
            if e.type == pygame.QUIT:
                exit()
            elif e.type == pygame.KEYDOWN:
                if e.key == pygame.K_p:
                    if self.estado == "Jogando":
                        self.estado = "Pausado"
                    else:
                        self.estado = "Jogando"